import "Turbine"
import "Turbine.UI"
import "Turbine.UI.Lotro"
import "Turbine.Gameplay"
import "Deusdictum.UI.Dragbar"
import "JackdawPlugins.BuffFrame.Function"
import "JackdawPlugins.BuffFrame.Icon"
import "JackdawPlugins.BuffFrame.Frame"

--Table to hold the "Icons" - the buff icons, plus timer bar.
icons={}

--Create the five buff frames. Note times (in seconds) here also.
BuffFrame={}
	
BuffFrame[1]=Frame("Long Duration")
BuffFrame[2]=Frame("Medium Duration")		medium=180
BuffFrame[3]=Frame("Short Duration")			short=30
BuffFrame[4]=Frame("DeBuffs")

Player = Turbine.Gameplay.LocalPlayer.GetInstance()
effects = Player:GetEffects()

--Event handlers
handle1 = AddCallback(effects, "EffectAdded", function(sender, args ) AddEffects(args.Index) end)
handle2 = AddCallback(effects, "EffectRemoved", function(sender, args ) RemoveEffects() end)
handle3 = AddCallback(effects, "EffectsCleared", function(sender, args ) RemoveEffects() end)

--Tooltip
Tooltip={}
Tooltip=Turbine.UI.Window()
	Tooltip:SetZOrder(999)
	Tooltip:SetSize(200,110)
	Tooltip:SetMouseVisible(false)

Text1=	Turbine.UI.Label()
	Text1:SetParent( Tooltip )
	Text1:SetPosition( 0, 0 )
	Text1:SetSize( 200, 20 )
	Text1:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 0.2 ) )
	Text1:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter )
Text2=	Turbine.UI.Label()
	Text2:SetParent( Tooltip )
	Text2:SetPosition( 0, 20 )
	Text2:SetSize( 200, 20 )
	Text2:SetBackColor( Turbine.UI.Color( 0, 0, 0 ) )
	Text2:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter )
Text3=	Turbine.UI.Label()
	Text3:SetParent( Tooltip )
	Text3:SetPosition( 0, 40 )
	Text3:SetSize( 200, 70 )
	Text3:SetBackColor( Turbine.UI.Color( 0, 0, 0 ) )
	Text3:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter )

--Load and/or save
local BuffFrameData=Turbine.PluginData.Load( Turbine.DataScope.Character, "BuffFrame" )

VitButtonData={}

	if BuffFrameData~=nil then
		for i=1,#BuffFrameData do
			BuffFrame[i].Window:SetPosition(BuffFrameData[i].x,BuffFrameData[i].y)
			BuffFrame[i].scale=BuffFrameData[i].scale
			BuffFrame[i].sx,BuffFrame[i].sy=BuffFrameData[i].sx,BuffFrameData[i].sy
			
			if BuffFrameData[i].scale==nil then BuffFrame[i].scale=1 end

			if BuffFrameData[i].sx==nil then 
				if o==1 or o==2 then 
					BuffFrame[i].sx,BuffFrame[i].sy=1,10
				else 
					BuffFrame[i].sx,BuffFrame[i].sy=10,1
				end
			end
			
			BuffFrame[i]:Resize()
			BuffFrame[i]:SetOrientation(BuffFrameData[i].o)
		end
		
		--If new frames have been added then fill in default data
		for i=#BuffFrameData+1, #BuffFrame do
			BuffFrame[i].Window:SetPosition(0,37*(i-1))
			BuffFrame[i].scale=1
			BuffFrame[i].sx,BuffFrame[i].sy=10,1
			
			BuffFrame[i]:Resize()
			BuffFrame[i]:SetOrientation(2)
		end
		
		ignorelist=BuffFrameData[1].ignorelist
		if ignorelist==nil then 	ignorelist={} end
		
		shown=BuffFrameData[1].shown
		
		VitButtonData.X=BuffFrameData[1].vx or 100
		VitButtonData.Y=BuffFrameData[1].vy or 100
		VitButtonData.Scale=BuffFrameData[1].vs or 1
	else
		for i=1,#BuffFrame do
			BuffFrame[i].Window:SetPosition(0,37*(i-1))
			BuffFrame[i].scale=1
			BuffFrame[i].sx,BuffFrame[i].sy=10,1
			
			BuffFrame[i]:Resize()
			BuffFrame[i]:SetOrientation(2)
		end
		ignorelist={}
		shown=true
		VitButtonData.X=100
		VitButtonData.Y=100
		VitButtonData.Scale=1
	end
	
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Vitals, shown )

	Plugins["BuffFrame"].Unload = function( sender, args )
		Turbine.Shell.WriteLine("Saved Buff Frame Data")
		BuffFrameData={}
		for i=1,#BuffFrame do
			BuffFrameData[i]={}
			BuffFrameData[i].x,BuffFrameData[i].y=BuffFrame[i].Window:GetPosition()
			BuffFrameData[i].scale=BuffFrame[i].scale
			BuffFrameData[i].sx,BuffFrameData[i].sy=BuffFrame[i].sx,BuffFrame[i].sy
			BuffFrameData[i].o=BuffFrame[i].Window.o
		end
			BuffFrameData[1].shown=shown
			BuffFrameData[1].ignorelist=ignorelist
			BuffFrameData[1].vx=VitButtonData.X
			BuffFrameData[1].vy=VitButtonData.Y
			BuffFrameData[1].vs=VitButtonData.Scale
			Turbine.PluginData.Save( Turbine.DataScope.Character, "BuffFrame", BuffFrameData )
	end
	
import "JackdawPlugins.BuffFrame.Button"

--Add all the effects currently on the player.
addall()